<?php
define('IN_COPPERMINE', true);
define('ADDPIC_PHP', true);

require('include/init.inc.php');
require('include/picmgmt.inc.php');

if (!GALLERY_ADMIN_MODE) die('Access denied');

$version = "Beta 4";

if (substr(COPPERMINE_VERSION,0,3) != "1.4" && substr(COPPERMINE_VERSION,0,3) != "1.3") die('Wrong CPG Version ' . COPPERMINE_VERSION . ' ! This batch only works with cpg 1.3.x and 1.4.x');

echo <<< EOT
<html>
<head>
<script language="JavaScript1.2">
function confirmAction(form) {
	if( form.submitButton != '' ) {
		return confirm(form.submitMessage)
	}
}
</script>
</head>
<body>
EOT;

ob_end_flush();

register_shutdown_function('reload');

$db_query_wrapper = (function_exists('db_query')) ? 'db_query' : 'cpg_db_query';

function check_mysql_version() {
	global $CONFIG, $db_query_wrapper;
	$sql = "SELECT VERSION()";
    $result = $db_query_wrapper($sql);
	if ( mysql_num_rows($result) > 0 ) {
		$row = mysql_fetch_row($result);
		if ( $row[0] =~ "^(?:4\.1|5\.)" ) {
			return 1;
		} else {
			return 0;
		}		
	} else {
		return 0;		
	}
}

function check_remote_sql() {
	global $CONFIG, $db_query_wrapper;
	$sql = "SHOW TABLES LIKE '" . $CONFIG['TABLE_PREFIX'] . "remote_log'";
    $result = $db_query_wrapper($sql);
	$retval = ( mysql_num_rows($result) == 0 ) ? 0 : 1;
	return $retval;
}

function create_remote_sql() {
	global $CONFIG, $db_query_wrapper;
	$sql = "CREATE TABLE `" . $CONFIG['TABLE_PREFIX']. "remote_log` ( `rlogid` bigint(20) NOT NULL auto_increment, `path` varchar(255) default NULL, `status` tinyint(4) NOT NULL default '0', PRIMARY KEY (`rlogid`) ) ENGINE=MyISAM DEFAULT CHARSET=latin1 SELECT pid, user1 as `username`, user2 as `sourcepage`, user3 as `pageurl`, user4 as `picurl` FROM `" . $CONFIG['TABLE_PICTURES'] . "` WHERE user4<>''";
	$db_query_wrapper($sql);
}

function delete_remote_sql() {
	global $CONFIG, $db_query_wrapper;
	$sql = "DROP TABLE `" . $CONFIG['TABLE_PREFIX'] . "remote_log`";
	$db_query_wrapper($sql);
}

function purge_remote_sql() {
	global $CONFIG, $db_query_wrapper;
	$sql = "DELETE FROM `" . $CONFIG['TABLE_PREFIX'] . "remote_log`";
	$db_query_wrapper($sql);
}

function synch_remote_sql() {
	global $CONFIG, $db_query_wrapper;
	$sql = "INSERT INTO " . $CONFIG['TABLE_PREFIX'] . "remote_log (pid,picurl,pageurl) SELECT pid, user4, user3 FROM " . $CONFIG['TABLE_PICTURES'] . " WHERE pid NOT IN (SELECT pid FROM " . $CONFIG['TABLE_PREFIX'] . "remote_log)";
	$db_query_wrapper($sql);
}

function remote_log_addpicture($url,$purl,$sourcepage,$username) {
	global $CONFIG, $db_query_wrapper;
	if ( trim($url) != "" ) {
		$sql = "Select rlogid FROM " . $CONFIG['TABLE_PREFIX'] . "remote_log WHERE picurl='" . addslashes($url) . "'";
		$result = $db_query_wrapper($sql);
		# log new entry
		if ( mysql_num_rows($result) == 0 ) {
			$sql = "SELECT pid FROM " .  $CONFIG['TABLE_PICTURES'] . " WHERE user4='" . addslashes($url) . "'";
			$result = $db_query_wrapper($sql);
			if ( mysql_num_rows($result) > 0 ) {
				$row = mysql_fetch_row($result);
				$pid = $row[0];
				$sql = "INSERT INTO " . $CONFIG['TABLE_PREFIX'] . "remote_log (pid,picurl,pageurl,username,sourcepage) VALUES (" . $pid . ",'" . addslashes($url) . "','" . addslashes($purl) . "','" . addslashes($username) . "','" . addslashes($sourcepage) . "')";
				$db_query_wrapper($sql);
			}
		# update existing entry
		} else {
			$sql = "SELECT pid FROM " .  $CONFIG['TABLE_PICTURES'] . " WHERE user4='" . addslashes($url) . "'";
			$result = $db_query_wrapper($sql);
			if ( mysql_num_rows($result) > 0 ) {
				$row = mysql_fetch_row($result);
				$pid = $row[0];
				$sql = "UPDATE " . $CONFIG['TABLE_PREFIX'] . "remote_log SET pid=" . $pid . " WHERE picurl='" . addslashes($url) . "'";
				$db_query_wrapper($sql);
			}
		}
	}
}


function add_picture_wrapper($aid, $path, $filename, $url, $purl, $sourcepage, $username) {
	global $CONFIG;

	switch (substr(COPPERMINE_VERSION,0,3)) 
	{
	case "1.4":
		//if ( $CONFIG['user_field3_name'] == "Remote Page URL" ) {
			return add_picture($aid, $path, $filename, 0, '', '', '', $username, $sourcepage, $purl, $url);
		/*
		} else {
			return add_picture($aid, $path, $filename, 0, '', '', '', '', '', '', $url);			
		}
		*/
		break;
	case "1.3":
		//if ( $CONFIG['user_field3_name'] == "Remote Page URL" ) {
			return add_picture($aid, $path, $filename, '', '', '', $username, $sourcepage, $purl, $url);
		/*
		} else {
			return add_picture($aid, $path, $filename, '', '', '', '', '', '', $url);
		}
		*/
		break;
	default:
		return false;
	}
}

function cleanupfilelist() {
	global $filelist, $CONFIG, $db_query_wrapper;

	if (check_remote_sql() && $_POST['override'] != "1") {
		$sql = "SELECT picurl FROM {$CONFIG['TABLE_PREFIX']}remote_log WHERE picurl <> '' ORDER BY rlogid ASC";
	} else {
		$sql = "SELECT user4 FROM {$CONFIG['TABLE_PICTURES']} WHERE user4 <> '' ORDER BY aid ASC";		
	}
    $result = $db_query_wrapper($sql);
	$cnt = count($filelist);
	$dbcnt = mysql_num_rows($result);
	while($row = mysql_fetch_row($result)) {
		unset($filelist[$row[0]]);
	}
	flush();

	echo $cnt . " Remote Pictures Links Found<br />";
	echo $dbcnt . " Remote Pictures in the database<br />";
	echo "After filtering " . count($filelist) . " NEW Remote Pictures will be added.<br />";
}


function populatealbums()
{
	global $filelist, $counter;
	
	$lim = $_POST['hardlimit'] > 0 ? $_POST['hardlimit'] : getrandmax();
		
	foreach ($filelist as $url => $arr)
	{
		if ($counter < $lim)
		{
			set_time_limit(180);
			addpic($url, $arr[0], $arr[1], $arr[2], $arr[3], $arr[4]);
			unset($filelist[$url]);
			usleep($_POST['sleep'] * 1000);
			$counter++;
		}
	}
}

function createstructure($path) {
	$aid = 0;
	$parent = 0;
	$npath = trim(preg_replace('/[^a-zA-Z0-9\/\@\.\-_]/', ' ', $path));
	// validate path and create it if required
	if ( substr($npath,0,1) == "/" && $npath != "/" ) {
		$npath = trim($npath,"/");
		$arr = explode("/",$npath);
		$npath = "";
		for ($i = 0; $i < count($arr); $i++) {
			// Skip if name is empty
			if ( $arr[$i] != "" ) {
				// rebuild the new path
				$npath .= "/" . trim($arr[$i]);

				// create category
				if ( $i < count($arr)-1 ) {
					$parent = createcategory($parent, trim($arr[$i]), $npath);
					
					// if an error occured, return with error
					if ( $parent == -1 ) {
						echo "WARNING: An error occured while creating the category : " . $npath . "<br \>This path will be discarded. No pictures in this path will be added !!<br \>";
						return array(-1, "");
					}

				// create album
				} else {
					$aid = createalbum($parent, trim($arr[$i]), $npath);

					// if an error occured, return with error
					if ( $aid == -1 ) {
						echo "WARNING: An error occured while creating the album : " . $npath . "<br \>This path will be discarded. No pictures in this path will be added !!<br \>";
						return array(-1, "");
					}
				}
			}
		}
	}
	return array($aid, $npath);
}

function createcategory($parent, $name, $path)
{
	global $CONFIG, $db_query_wrapper;

	// check if the directory already exists
	if ( ! is_dir(trim($CONFIG['fullpath'],"/") . $path) ) {
		//create the new directory or exit with error
		if ( ! mkdir(trim($CONFIG['fullpath'],"/") . $path, 0750) ) return -1;
	}

	$sql = "SELECT cid " . "FROM {$CONFIG['TABLE_CATEGORIES']} " . "WHERE name='" . addslashes($name) . "' AND parent=" . (INT)$parent . " LIMIT 1";
    $result = $db_query_wrapper($sql);

    if (mysql_num_rows($result)) {
		echo "Category already exists: " . $name . "<br />";
		$row = mysql_fetch_row($result);
		$cid = $row[0];
	} else {
		$db_query_wrapper("INSERT INTO {$CONFIG['TABLE_CATEGORIES']} (pos, parent, name) VALUES ('10000', '$parent', '" . addslashes($name) . "')");
		echo "Category Created: " . $name . "<br/>";
		$cid = mysql_insert_id();
	}
	flush();

	return $cid;
}

function createalbum($category, $title, $path)
{
	global $CONFIG, $db_query_wrapper;

	// check if the directory already exists
	if ( ! is_dir(trim($CONFIG['fullpath'],"/") . $path) ) {
		//create the new directory or exit with error
		if ( ! mkdir(trim($CONFIG['fullpath'],"/") . $path, 0750) ) return -1;
	}

	$sql = "SELECT aid " . "FROM {$CONFIG['TABLE_ALBUMS']} " . "WHERE title='" . addslashes($title) . "' AND category=" . (INT)$category . " LIMIT 1";
    $result = $db_query_wrapper($sql);

    if (mysql_num_rows($result)) {
		echo "Album already exists: " . $title . "<br />";
		$row = mysql_fetch_row($result);
		$aid = $row[0];
	} else {
		$db_query_wrapper("INSERT INTO {$CONFIG['TABLE_ALBUMS']} (category, title, pos) VALUES ('".(INT)$category."', '" . addslashes($title) . "', '10000')");
		echo "Album Created:" . $title . "<br />";
		$aid = mysql_insert_id();
	}
	flush();

	return $aid;
}

function buildfilelist($data) {
	global $filelist;

	// init starting album id / path
	$aid = 0;
	$path = "/";
	foreach ( $data as $key => $value ) {
		$value = trim($value);
		// new localtion, build location structure, get album id
		if ( substr($value,0,1) == "/" ) {
			list($aid, $path) = createstructure($value);
		// new entry
		} else {
			// skip pictures in erroneous path
			if ( $aid > 0 ) {
				$urls = explode("\\",$value);
				if ( strtolower(substr(trim($urls[0]),0,4)) == "http" ) {
					$filelist[trim($urls[0])] = array($aid, $path, trim($urls[1]), trim($urls[2]), trim($urls[3]));
					echo "Adding to list: " . trim($urls[0]) . "<br \>";
				} else {
					echo "Unknow entry (ignored): " . $value . "<br \>";
				}
			}
		}
	}
}


function addpic($url, $aid, $path, $purl, $sourcepage, $username)
{
	global $CONFIG, $db_query_wrapper;

	// Open Remote File
	$dataFile = fopen( $url, "rb" );
	if ( $dataFile )
	{
		// Build local path 
		if ( $path != "/" ) {
			$fullpath = trim($CONFIG['fullpath'],"/") . $path . "/";
		} else {
			$fullpath = $CONFIG['fullpath'];
		}
		// Sanitize the local file name
		$sane_name = str_replace('%20', '_', basename($url));
		$sane_name = preg_replace('/[^a-zA-Z0-9\.\-_]/', '_', $sane_name);
		$sane_name = preg_replace('/[^a-zA-Z0-9\.\-_]/', '_', $sane_name);
		while ( strpos($sane_name,'__') != FALSE ) {
			$sane_name = str_replace('__', '_', $sane_name);
		}

		// Make sure the file has not been already added, based on the source url, destination directory and the sanitized local filename
		$sql = "SELECT pid " . "FROM {$CONFIG['TABLE_PICTURES']} " . "WHERE filepath='" . addslashes(ltrim($path,"/")."/") . "' AND filename='" . addslashes($sane_name) . "' AND user4='" . addslashes($url) . "' LIMIT 1";
		$result = $db_query_wrapper($sql);
		if (mysql_num_rows($result)) {
			echo "Picture already added: " . $url . " to path: " . $path . "<br />";
		} else {
			// Build the destination file full path
			$destimage = $fullpath . $sane_name;
			$c = 0;
			while ( file_exists($destimage) )
			{
				$c++;
				$destimage = $fullpath . $c . '_' . $sane_name;
			}

			// Open the destination file for writing.
			$fpw = fopen($destimage, "xb");
			if ( $fpw ) {
				while (!feof($dataFile)) {
				   $buffer = fgets($dataFile, 8192);
					if (fwrite($fpw, $buffer, strlen($buffer)) === 'FALSE') {
						fclose($fpw);
						unlink($destimage);
						break;
					}
				}
				if ( is_resource($fpw) === true ) {
					fclose($fpw);
				}
			}

			// Add the picture 
			if ( file_exists($destimage) ) {			
				if ( add_picture_wrapper($aid, ltrim($path,"/")."/", basename($destimage), $url, $purl, $sourcepage, $username) ) {
					remote_log_addpicture($url, $purl, $sourcepage, $username);
					echo "Remote Picture added: " . $url . " as File: " . $destimage . "<br />";

					// Remove Fullsize image.
					unlink($destimage);
					touch($destimage);
					
				} else {
					echo "Remote Picture failed: " . $url . " as File: " . $destimage . "<br />"; 
					unlink($destimage);
				}
			} else {
				echo "Error ! The Remote File could not be added: " . $url . "<br />";
			}
		}
		flush();
		ob_end_flush();
	} else {
		echo "Error ! The Remote File could not be accessed: " . $url . "<br />";
	}
	fclose($dataFile);
}


function reload()
{
	global $filelist, $counter;
	
	if (count($_POST) == 0) exit();
	
	$remaining = count($filelist);

	if ( $remaining > 0 ) {
	
		$filelist = base64_encode(serialize($filelist));
		$auto = (isset($_POST['auto']) && $_POST['auto']) ? 'checked = "checked"' : '';
		$js = ($_POST['auto'] && $remaining) ? '<script type="text/javascript"> onload = document.form.submit();</script>' : ''; 
		$counter = $counter ? "$counter files added" : "structure created";
		$sleep = isset($_POST['sleep'])  ? $_POST['sleep'] : '1000';
		$hardlimit = isset($_POST['hardlimit'])  ? $_POST['hardlimit'] : '0';

		$scriptname = $_SERVER['SCRIPT_NAME'];
		
		if (!connection_aborted()) echo <<< EOT
		
		$counter, $remaining files to add.<br />
		<form name="form" method="POST" action="$scriptname">
			<input name="filelist" type="hidden" value="$filelist">
			Sleep: <input type="text" name="sleep" value="$sleep">
			Limit: <input type="text" name="hardlimit" value="$hardlimit">
			<input type="submit" value="continue">
			Autorun: <input type="checkbox" name="auto" value="1" $auto>
			<input type="hidden" name="override" value="{$_POST['override']}">
		</form>
		$js
EOT;

	} else {
		if (!connection_aborted()) echo <<< EOT
			<br />Back to the main form : <a href="$scriptname">Back</a>
EOT;
	}
}
	
function countup($array)
{
	$result = 0;

	foreach ($array as $a)
		$result += is_array($a) ? countup($a) : count($a);

	return $result;
}

if (isset($_POST['filelist'])){

	$filelist = unserialize(base64_decode($_POST['filelist']));
	$counter = 0;
	
	populatealbums();

} elseif (isset($_POST['start'])) {

	// Test for a blank file upload box.
	if ( !empty($_FILES['file_upload_array']['tmp_name'][0]) && is_uploaded_file($_FILES['file_upload_array']['tmp_name'][0]) ) {

		echo "File Uploaded : " . $_FILES['file_upload_array']['name'][0] . "<br />";	
		echo "File Size : " . $_FILES['file_upload_array']['size'][0] . "<br />";	
		$data = file($_FILES['file_upload_array']['tmp_name'][0]);

		buildfilelist($data);

		cleanupfilelist();

	} else {

		echo "Nothing Uploaded.<br>";
	}
} else {
	$scriptname = $_SERVER['SCRIPT_NAME'];
	if (check_remote_sql()) {
		$override = "Override Remote Log: <input type='checkbox' name='override' value='1'><br /><br />";
	}
	echo <<< EOT

This is the remote batch add tool version : $version<br />
You can find further info on this CPG hack here : <a href="http://coppermine-gallery.net/forum/index.php?topic=22564.0" target="_blank">coppermine-gallery.net forum</a><br /><br />

<form method="POST" action="$scriptname" ENCTYPE="multipart/form-data">
	List of Remote Files to add: <input type="file" name="file_upload_array[]" size="40"><br /><br />
	Sleep between additions (ms): <input type="text" name="sleep" value="1000"><br /><br />
	Run unattended: <input type="checkbox" name="auto" value="1"><br /><br />
	$override
	Limit additions per refresh: <input type="text" name="hardlimit" value="10"><br /><br />
	<input type="submit" name="start" value="Begin">
</form>

EOT;

	if (isset($_POST['rlogaction'])){
		echo "<br /><hr size='1' width='500' color='#000000'><br /><b>Performing Remote Log Action:</b> " . $_POST['rlogaction'] . "<br />";
		switch ($_POST['action']) {
		case "Synchronize":
			if (check_mysql_version()) {
				synch_remote_sql();
				echo "Remote Log table synchronized.<br />";
			} else {
				echo "Your MySQL version is not compatible with this operation, you nee MySQL 4.1+.<br />";
			}
			break;
		case "Purge":
			purge_remote_sql();
			echo "Remote Log table purged.<br />";
			break;
		case "Remove":
			delete_remote_sql();
			echo "Remote Log table removed.<br />";
			break;
		case "Create":
			create_remote_sql();
			echo "Remote Log table created.<br />";
			break;
		default:
			echo "Unknow Action.<br />";
		}
	}

	if (check_remote_sql()) {
		echo <<< EOT
<br><hr size="1" width="500" color="#000000"><br>
<form method="POST" action="$scriptname" ENCTYPE="multipart/form-data" OnSubmit="return confirmAction(this);">
Remote log options : <!--<input type="submit" name="action" value="Synchronize" OnClick="this.form.submitButton = this.name; this.form.submitMessage = 'Synchronize your Remote Log ?';">&nbsp;--><input type="submit" name="action" value="Purge" OnClick="this.form.submitButton = this.name; this.form.submitMessage = 'Purge your Remote Log ?';">&nbsp;<input type="submit" name="action" value="Remove" OnClick="this.form.submitButton = this.name; this.form.submitMessage = 'Delete the Remote Log Table ?';">
<input type="hidden" name="rlogaction" value="yes">
</form>

EOT;
	} else {
		echo <<< EOT
<br><hr size="1" width="500" color="#000000"><br>
<form method="POST" action="$scriptname" ENCTYPE="multipart/form-data" OnSubmit="return confirmAction(this);">
Remote log options : <input type="submit" name="action" value="Create" OnClick="this.form.submitButton = this.name; this.form.submitMessage = 'Create the Remote Log ?';">
<input type="hidden" name="rlogaction" value="yes">
</form>

EOT;
	}
}

echo <<< EOT
</body>
</html>
EOT;
?>